<div id="content">
    <h1>Генератор sitemap.xml</h1>
    <p>
        <label for="url">URL сайта</label>
        <input type="text" name="url" id="URL" value="<?=SITE_URL?>">
    </p>
    <p id="sitemap_settings">
        <label><input type="radio" name="saving_type" id="save_at_root" value="0" checked> Сохранить в корень сайта</label><br>
        <label><input type="radio" name="saving_type" value="1"> Скачать карту</label><br>
        <label><input type="checkbox" id="make_archive" checked> Архивировать карту (формат .gz)</label><br>
        <label>
        <input type="button" id="start" value="Начать индексацию">
    </p>
    <p id="indexation_msg"></p>
</div>

<script>

var map = new Array();
var mapOldLength = 0;
var badPages = new Array();
var stopFlag = true;

$(window).ready(function() {
    $('#start').click(function() {
        $('#sitemap_settings').css('display', 'none');
        var URL = $('#URL').val();
        if (URL.substr(0, 7) != 'http://' && URL.substr(0, 8) != 'https://') {
            URL = "http://"+URL;
            $('#URL').val(URL);
        }
        if (URL.charAt(URL.length-1) == '/') URL = URL.substr(0,URL.length-1);
        stopFlag = false;
        $('#sitemap_xml').text('');
        var interval = setInterval(function() {
            if (mapOldLength >= map.length && map.length > 0) {
                clearInterval(interval);
                stopFlag = true;
                var result = map.filter(function(value){return badPages.indexOf(value) == -1})
                $.post(
                    '<?=SITE_URL?>/admin/universal_sitemap_generator/ajax_create_sitemap_xml',
                    {
                        'map': JSON.stringify(result),
                        'saveAtRoot': $('#save_at_root').is(':checked') ? '1' : '0',
                        'isArchive': $('#make_archive').is(':checked') ? '1' : '0'
                    },
                    function(response) {$('#indexation_msg').html(response)}
                );
            } else {
                mapOldLength = map.length;
            }
        }, 5000);
        generateMap(URL);
    
    });
});



function generateMap(URL) {
    if (!stopFlag && map.indexOf(URL) == -1 && map.length < 10000) {

        map.push(URL);

        $('#indexation_msg').text('Идет индексация. Найдено страниц: '+map.length);

        $.ajax({
            'url': '<?=SITE_URL?>/admin/universal_sitemap_generator/ajax_getfile/url='+btoa(URL),
            'dataType': 'text',
            'type': 'GET',
            'success': function(data, textStatus) {
                if (data != '') {               
                    data = data.replace(/<!--(?:[\s\S](?!-->))*[\s\S]?-->/g, '');//удалить комментарии
                    var links = new Array();
                    var rgxp = /<a[^>]*href\s*=\s*(?:"|')?([^"'\s>]*)(?:"|')?/gi;//поиск ссылок
                    var result;
                    while (result = rgxp.exec(data)) links.push(result[1]);

                    result = URL.match(/^(https?:\/\/)([^\/]+)(.*)$/);
                    var protocol = result[1];
                    var host = result[2];
                    var uri = result[3];
                    for (var i=0; i<links.length; i++) {
                        links[i] = getAbsoluteURL(protocol, host, uri, links[i]);
                        if (links[i] != false && map.indexOf(links[i]) == -1) {
                            generateMap(links[i]);
                        }
                    }
                } else {
                    badPages.push(URL);
                }
            },
            'error': function(jqXHR, error, status) {
                badPages.push(URL);
            }
        });
    }
}



function getAbsoluteURL(protocol, host, uri, URL) {
    if (URL.substr(0,2) == '//') {
        //абсолютные без протокола
        var r = URL.match(/^\/\/([^\/]+)/);
        if (r == null || r[1] != host) {
            return false;
        } else {
            URL = protocol + URL.substr(2,URL.length-2);
        }  
    } else if (URL.charAt(0) == '/') {
        //полуотносительные ссылки
        URL = protocol + host + URL;
    } else if (URL.substr(0,7) == 'http://' || URL.substr(0,8) == 'https://') {
        //абсолютные ссылки
        var r = URL.match(/^https?:\/\/[^\/]+/);
        if (r == null || r[0] != protocol + host) {
            return false;
        }
    } else {
        //относительные ссылки
        return false;
    }
    URL = URL.replace(/#[^\/]*$/, '');
    if (URL.charAt(URL.length-1) == '/') URL = URL.substr(0,URL.length-1);
    var ext = URL.substr(URL.lastIndexOf('.')+1);
    ext = ext.toLowerCase();
    if (ext == 'jpg' || ext == 'jpeg' || ext == 'png' || ext == 'gif') return false;
    else return URL;
}
</script>